# These macros reflect the locations and user Apache is configured to
# run with and as on RHL 6.x.

# First, where documents are stored.  This affects where icons are placed.
%define contentdir /home/httpd

# Now the place where mailman binaries go.
%define mmdir /usr/share/mailman

# Now the place where mutable data goes.
%define varmmdir /usr/share/mailman

# Now, the user and group the CGIs will expect to be run under.  This should
# match the user and group the web server is configured to run as.  The scripts
# will error out if they are invoked by any other user.
%define cgiuser    nobody
%define cgiuserid  99
%define cgigroup   nobody
%define cgigroupid 99

# Now, the user and group the scripts will actually execute as.
%define user       mailman
%define userid     41
%define group      mailman
%define groupid    41

# Now, the groups your mail spoolers run as.  Sendmail uses 'mail'(12)
# and postfix uses 'nobody'(99).
%define mailgroup  mail,nobody
%define mailgid    12,99

Summary: Mailing list manager with built in Web access.
Name: mailman
Version: 2.0.13
Release: 0.6.2
Epoch: 3
Group: Applications/Internet
Source0: ftp://ftp.gnu.org/pub/gnu/mailman/mailman-%{version}.tgz
#Source0:  http://unc.dl.sourceforge.net/sourceforge/mailman/mailman-%{version}.tgz
Source1: mm_cfg.py
Source2: mailman-README.REDHAT
Source3: httpd-mailman.conf
Source4: mailman.logrotate
Patch0: mailman-2.0.9-multimail.patch
Patch1: mailman-2.0.9-admin.patch
License: GPL
URL: http://www.list.org/
BuildRoot: %{_tmppath}/%{name}-root
Prereq: shadow-utils, /usr/bin/newaliases, /usr/bin/crontab
Requires: webserver, python >= 1.5.2, mktemp

%description 
Mailman is software to help manage email discussion lists, much like
Majordomo and Smartmail. Unlike most similar products, Mailman gives
each mailing list a webpage, and allows users to subscribe,
unsubscribe, etc. over the Web. Even the list manager can administer
his or her list entirely from the Web. Mailman also integrates most
things people want to do with mailing lists, including archiving, mail
<-> news gateways, and so on.

When the package has finished installing, you will need to:

* Run %{mmdir}/bin/mmsitepass to set the mailman administrator password.
* Edit %{mmdir}/Mailman/mm_cfg.py to configure Mailman for your site.
* Add "Include conf/httpd-mailman.conf" to /etc/httpd/conf/httpd.conf.

Users upgrading from previous releases of this package may need to
move their data or adjust the configuration files to point to the
locations where their data is.

%prep
%setup -q
%patch0 -p1 -b .multimail
%patch1 -p1 -b .admin
cp $RPM_SOURCE_DIR/mailman-README.REDHAT README.REDHAT
aclocal
autoconf

%build
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS
FQDN=localhost.localdomain \
URL=localhost.localdomain \
MAILMAN_UID=%{userid} \
MAILMAN_GID=%{groupid} \
MAIL_GID=%{mailgid} \
CGI_UID=%{cgiuserid} \
CGI_GID=%{cgigroupid} \
./configure \
	--prefix=%{mmdir} \
	--with-var-prefix=%{varmmdir} \
	--with-python=%{__python} \
	--with-mail-gid=%{mailgroup} \
	--with-cgi-id=%{cgiuser} \
	--with-cgi-gid=%{cgigroup}
cp %{SOURCE1} Mailman/mm_cfg.py.dist
make
	
%install
rm -fr $RPM_BUILD_ROOT
# Normal install.
make install prefix=$RPM_BUILD_ROOT%{mmdir} var_prefix=$RPM_BUILD_ROOT%{varmmdir}

# Create directories we'll use for log and spool files.
install -m775 -d $RPM_BUILD_ROOT/var/log/mailman
install -m775 -d $RPM_BUILD_ROOT/var/spool/mailman/qfiles

# Clean out any byte-compiled python modules and recompile them.
find $RPM_BUILD_ROOT%{mmdir} -name "*.pyc" -exec rm -fv '{}' ';'
python -c 'from compileall import *; compile_dir("'$RPM_BUILD_ROOT'%{mmdir}",10,"%{mmdir}")'

# Copy the icons into the web server's icons directory.
mkdir -p $RPM_BUILD_ROOT%{contentdir}/icons
cp misc/*.jpg misc/*.png $RPM_BUILD_ROOT%{contentdir}/icons

# Create a link to the wrapper in /etc/smrsh to allow sendmail to run it.
mkdir -p $RPM_BUILD_ROOT/etc/smrsh
ln -s ../..%{mmdir}/mail/wrapper $RPM_BUILD_ROOT/etc/smrsh/wrapper
diff -u $RPM_BUILD_ROOT/%{mmdir}/mail/wrapper $RPM_BUILD_ROOT/etc/smrsh/wrapper

# Install a logrotate control file.
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/mailman.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/mailman

# Install the httpd configuration file.
install -m755 -d $RPM_BUILD_ROOT/etc/httpd/conf
install -m644 /dev/null $RPM_BUILD_ROOT/etc/httpd/conf/httpd-mailman.conf
sed -e 's|@VARMMDIR@|%{varmmdir}|g' -e 's|@MMDIR@|%{mmdir}|g' \
	$RPM_SOURCE_DIR/httpd-mailman.conf > \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd-mailman.conf

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/files.%{name}

%pre
/usr/sbin/useradd -s /bin/false -c "GNU Mailing List Manager" -d %{mmdir} -M -r -u 41 mailman 2> /dev/null || :

%post
if [ ! -f /var/spool/cron/mailman ]; then
  crontab -u mailman %{mmdir}/cron/crontab.in
fi
if ! grep -q "mailman-owner" /etc/aliases 2> /dev/null ; then
  cat >> /etc/aliases << EOF
# mailman aliases
mailman: postmaster
mailman-owner: mailman
EOF
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%postun
if [ $1 = 0 ]; then
  crontab -u mailman -r
  TMPFILE=`mktemp /etc/aliasesXXXXXX`
  if test -n "$TMPFILE" ; then
    egrep -E -v 'mailman aliases|mailman:|mailman-owner:' /etc/aliases >${TMPFILE}
    mv ${TMPFILE} /etc/aliases
  fi
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS BUGS FAQ NEWS README README.LINUX TODO UPGRADING INSTALL
%doc gnu-COPYING-GPL README.REDHAT README.SENDMAIL README.QMAIL README.EXIM
%attr(0644,root,root) %{contentdir}/icons/*
%dir %{mmdir}
#%dir %{varmmdir}
%config %{mmdir}/Mailman
%config /etc/smrsh/wrapper
%config /etc/logrotate.d/mailman
%config /etc/httpd/conf/httpd-mailman.conf

%dir %{mmdir}/bin
%dir %{mmdir}/cgi-bin
%attr(2755,root,mailman) %{mmdir}/bin/*
%attr(2755,root,mailman) %{mmdir}/cgi-bin/*
%attr(2755,root,mailman) %{mmdir}/cron/
%attr(2775,root,mailman) %{mmdir}/mail/

%dir %{mmdir}/scripts/
%attr(2755,root,mailman) %{mmdir}/scripts/*

%config %{mmdir}/templates

%dir %attr(2775,root,mailman) %{varmmdir}/archives/
%attr(2775,root,mailman) %{varmmdir}/archives/public/
%attr(2771,root,mailman) %{varmmdir}/archives/private/

%attr(2775,root,mailman) %{varmmdir}/data/
%attr(2775,root,mailman) %{varmmdir}/filters/
%attr(2775,root,mailman) %{varmmdir}/lists/
%attr(2775,root,mailman) %{varmmdir}/locks/
%attr(2755,root,mailman) %{varmmdir}/spam/
%attr(2775,root,mailman) /var/log/mailman
%attr(2775,root,mailman) /var/spool/mailman

%changelog
* Fri Aug  2 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.13-0.6.2
- rebuild for SWS 3.2 / RHL 6.2

* Fri Aug  2 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.13-1
- specify log files individually, per faq wizard
- update to 2.0.13

* Wed May 22 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.11-1
- update to 2.0.11

* Fri Apr  5 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.9-1
- include README.QMAIL in with the docs (#58887)
- include README.SENDMAIL and README.EXIM in with the docs
- use an included httpd.conf file instead of listing the configuration
  directives in the %%description, which due to specspo magic might look
  wrong sometimes (part of #51324)
- interpolate the DEFAULT_HOST_NAME value in mm.cfg into both the DEFAULT_URL
  and MAILMAN_OWNER (#57987)
- move logs to /var/log/mailman, qfiles to /var/spool/mailman, rotate
  logs in the log directory (#48724)
- raise exceptions when someone tries to set the admin address for a list
  to that of the admin alias (#61468)

* Thu Apr  4 2002 Nalin Dahyabhai <nalin@redhat.com>
- fix a default permissions problem in %{_var}/mailman/archives/private,
  reported by Johannes Erdfelt
- update to 2.0.9

* Tue Apr  2 2002 Nalin Dahyabhai <nalin@redhat.com>
- make the symlink in /etc/smrsh relative

* Tue Dec 11 2001 Nalin Dahyabhai <nalin@redhat.com> 2.0.8-1
- set FQDN and URL at build-time so that they won't be set to the host the
  RPM package is built on (#59177)

* Wed Nov 28 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.8

* Sat Nov 17 2001 Florian La Roche <Florian.LaRoche@redhat.de> 2.0.7-1
- update to 2.0.7

* Wed Jul 25 2001 Nalin Dahyabhai <nalin@redhat.com> 2.0.6-1
- update to 2.0.6

* Mon Jun 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- code in default user/group names/IDs

* Wed May 30 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.5
- change the default hostname from localhost to localhost.localdomain in the
  default configuration
- chuck configuration file settings other than those dependent on the host name
  (the build system's host name is not a good default)  (#32337)

* Tue Mar 13 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.3

* Tue Mar  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.2

* Wed Feb 21 2001 Nalin Dahyabhai <nalin@redhat.com>
- patch from Barry Warsaw (via mailman-developers) to not die on
  broken Content-Type: headers

* Tue Jan  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.1

* Wed Dec  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0 final release
- move the data to %{_var}

* Fri Oct 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta 6

* Thu Aug  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- add note about adding FollowSymlinks so that archives work

* Wed Aug  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the default owner root again so that root owns the docs
- update to 2.0beta5, which fixes a possible security vulnerability
- add smrsh symlink

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta4
- change uid/gid to apache.apache to match apache (#13593)
- properly recompile byte-compiled versions of the scripts (#13619)
- change mailman alias from root to postmaster

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta3
- drop bugs and arch patches (integrated into beta3)

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- move web files to reside under %{contentdir}
- move files from /usr/share to %{_datadir}
- integrate spot-fixes from mailman lists via gnome.org

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Wed May 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- Update to 2.0beta2 to pick up security fixes.
- Change Requires: python to list >= 1.5.2

* Mon Nov  8 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- 1.1

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- 1.0 final.

* Tue Jun 15 1999 Preston Brown <pbrown@redhat.com>
- security fix for cookies
- moved to /usr/share/mailman

* Fri May 28 1999 Preston Brown <pbrown@redhat.com>
- fix up default values.

* Fri May 07 1999 Preston Brown <pbrown@redhat.com>
- modifications to install scripts

* Thu May 06 1999 Preston Brown <pbrown@redhat.com>
- initial RPM for SWS 3.0
